Index: /extensions/database_migration/CHANGELOG
===================================================================
--- /extensions/database_migration/CHANGELOG	(revision 6222)
+++ /extensions/database_migration/CHANGELOG	(revision 6222)
@@ -0,0 +1,3 @@
+database_migration 0.1.0 - 2010-05-18
+================================
+* first public version
Index: /extensions/database_migration/COPYING
===================================================================
--- /extensions/database_migration/COPYING	(revision 6222)
+++ /extensions/database_migration/COPYING	(revision 6222)
@@ -0,0 +1,339 @@
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+	    How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License along
+    with this program; if not, write to the Free Software Foundation, Inc.,
+    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.
Index: /extensions/database_migration/MANIFEST
===================================================================
--- /extensions/database_migration/MANIFEST	(revision 6222)
+++ /extensions/database_migration/MANIFEST	(revision 6222)
@@ -0,0 +1,34 @@
+database_migration/install.php
+database_migration/MANIFEST
+database_migration/maintain.inc.php
+database_migration/rsync_exclude
+database_migration/template/form.tpl
+database_migration/template/admin_restore.tpl
+database_migration/template/admin_migration.tpl
+database_migration/template/admin_config.tpl
+database_migration/template/admin_export.tpl
+database_migration/template/admin_import.tpl
+database_migration/template/admin.tpl
+database_migration/js/install.js
+database_migration/js/admin.js
+database_migration/main.inc.php
+database_migration/language/fr_FR/index.php
+database_migration/language/fr_FR/description.txt
+database_migration/language/fr_FR/plugin.lang.php
+database_migration/language/templates/index.php
+database_migration/language/templates/plugin.lang.php
+database_migration/language/en_UK/index.php
+database_migration/language/en_UK/plugin.lang.php
+database_migration/CHANGELOG
+database_migration/include/tab_export.inc.php
+database_migration/include/tab_config.inc.php
+database_migration/include/config.class.php
+database_migration/include/tab_restore.inc.php
+database_migration/include/tab_import.inc.php
+database_migration/include/tab_migration.inc.php
+database_migration/include/functions.inc.php
+database_migration/admin.php
+database_migration/Makefile
+database_migration/COPYING
+database_migration/css/admin.css
+database_migration/init.php
Index: /extensions/database_migration/admin.php
===================================================================
--- /extensions/database_migration/admin.php	(revision 6222)
+++ /extensions/database_migration/admin.php	(revision 6222)
@@ -0,0 +1,71 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+include_once PHPWG_ROOT_PATH .'admin/include/tabsheet.class.php';
+
+$me = get_plugin_data($plugin_id);
+$dm_base_url = get_admin_plugin_menu_link(__FILE__);
+
+if ($GLOBALS['conf']['dblayer']=='mysql') {
+  $Tabs = array('config' => l10n('Configuration'),
+		'export' => l10n('Export'),
+		'import' => l10n('Import'),
+		'migration' => l10n('Migration'));
+  $default_tab = 'config';
+} else {
+  $Tabs = array('restore' => l10n('Restore'));
+  $default_tab = 'restore';
+}
+
+if (!empty($_GET['tab']) && isset($Tabs[$_GET['tab']])) {
+  $page['tab'] = $_GET['tab'];
+} else {
+  $page['tab'] = $default_tab;
+}
+
+if (!empty($_SESSION['dm_messages']['infos'])) {
+  array_push($GLOBALS['page']['infos'], $_SESSION['dm_messages']['infos']);
+  unset($_SESSION['dm_messages']);
+} elseif (!empty($_SESSION['dm_messages']['errors'])) {
+  array_push($GLOBALS['page']['errors'], $_SESSION['dm_messages']['errors']);
+  unset($_SESSION['dm_messages']);
+}
+
+$tabsheet = new tabsheet();
+foreach ($Tabs as $key => $label) {
+  $tabsheet->add($key, $label, $dm_base_url.'&amp;tab='.$key);  
+}
+$tabsheet->select($page['tab']);
+$tabsheet->assign();
+
+include_once DM_PLUGIN_ROOT . '/include/tab_'.$page['tab'].'.inc.php';
+
+$GLOBALS['template']->set_filename('plugin_admin_content',  DM_TEMPLATE . '/admin.tpl');
+$GLOBALS['template']->assign('DM_TPL', DM_TEMPLATE);
+$GLOBALS['template']->assign('DM_CSS', DM_CSS);
+$GLOBALS['template']->assign('DM_JS', DM_JS);
+$GLOBALS['template']->assign('tab_content', DM_TEMPLATE . '/admin_' . $page['tab'] . '.tpl');
+$GLOBALS['template']->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
+?>
Index: /extensions/database_migration/css/admin.css
===================================================================
--- /extensions/database_migration/css/admin.css	(revision 6222)
+++ /extensions/database_migration/css/admin.css	(revision 6222)
@@ -0,0 +1,54 @@
+#content { 
+  text-align: left;
+}
+
+#content h3, fieldset, fieldset p { 
+  text-align: left;
+}
+
+#content h3, p { 
+  margin-left: 15px;
+}
+
+ul.actions { 
+  text-align: left;
+  margin: -20px 0 0 15px;
+  padding: 0;
+}
+
+ul.actions li a { 
+  margin-right: 5px;
+}
+
+p.field {
+  position: relative;
+}
+
+p.field label {
+  display: block;
+  width: 19em;
+  text-align: right;
+}
+
+p.field input, p.field select, p.field span.value {
+  display: inline;
+  position: absolute;
+  left: 20em;
+  top: 0;
+}
+
+ul.process { 
+  list-style-type: none;
+}
+
+ul.process li { 
+  margin-bottom: 10px;
+}
+
+.content table { 
+  margin: 20px 0 0 15px;
+}
+
+div.errors p, div.infos p { 
+  margin-left: 30px;
+}
Index: /extensions/database_migration/include/config.class.php
===================================================================
--- /extensions/database_migration/include/config.class.php	(revision 6222)
+++ /extensions/database_migration/include/config.class.php	(revision 6222)
@@ -0,0 +1,104 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+class dmConfig
+{
+  private $config = array(), $plugin_dir;
+
+  public function __construct($plugin_dir, $plugin_name) {
+    $this->plugin_dir = $plugin_dir;
+    $this->plugin_name = $plugin_name;
+
+    if (!file_exists($this->get_config_file_dir())) {
+      mkgetdir($this->get_config_file_dir());
+    }
+
+    if (!file_exists($this->get_config_filename())) {
+      $this->save_config();
+    }
+  }
+
+  public function load_config() {
+    $x = file_get_contents($this->get_config_filename());
+    if ($x!==false) {
+      $c = unserialize($x);
+      $this->config = $c;
+    }
+
+    if (!isset($this->config['connections'])) {
+      $this->config['connections'] = array();
+    }
+  }
+
+  public function save_config() {
+    file_put_contents($this->get_config_filename(), serialize($this->config));
+  }
+
+  private function get_config_file_dir() {
+    return $GLOBALS['conf']['local_data_dir'].'/plugins/';
+  }
+
+  private function get_config_filename() {
+    return $this->get_config_file_dir().basename($this->plugin_dir).'.dat';
+  }
+
+  public function __set($key, $value) {
+    $this->config[$key] = $value;
+  }
+
+  public function __get($key) {
+    return isset($this->config[$key])?$this->config[$key]:null;
+  }
+
+  public function plugin_admin_menu($menu) {
+    array_push($menu,
+	       array('NAME' => $this->plugin_name,
+		     'URL' => get_admin_plugin_menu_link($this->plugin_dir.'/admin.php')		 
+		     )
+	       );
+
+    return $menu;
+  }
+
+  public function addConnection($dblayer, $params) {
+    $this->config['connections'][$dblayer] = $params;
+  }
+
+  public function removeConnection($dblayer) {
+    if (isset($this->config['connections'][$dblayer])) {
+      unset($this->config['connections'][$dblayer]);
+    }
+  }
+
+  public function getConnection($dblayer) {
+    return isset($this->config['connections'][$dblayer])?$this->config['connections'][$dblayer]:null;
+  }
+
+  public function getAllConnections() {
+    $allConnections = $this->config['connections'];
+    if (isset($allConnections['mysql'])) {
+      unset($allConnections['mysql']);
+    }
+
+    return $allConnections;
+  }
+}
+?>
Index: /extensions/database_migration/include/functions.inc.php
===================================================================
--- /extensions/database_migration/include/functions.inc.php	(revision 6222)
+++ /extensions/database_migration/include/functions.inc.php	(revision 6222)
@@ -0,0 +1,54 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+function get_config_file_content($dblayer, $connection) {
+  global $conf;
+  
+  $content = '<?php
+$conf[\'dblayer\'] = \''.$dblayer.'\';
+$conf[\'db_base\'] = \''.$connection['db_base'].'\';
+$conf[\'db_user\'] = \''.$connection['db_user'].'\';
+$conf[\'db_password\'] = \''.$connection['db_password'].'\';
+$conf[\'db_host\'] = \''.$connection['db_host'].'\';
+
+$prefixeTable = \''.$connection['prefix'].'\';
+
+define(\'PHPWG_INSTALLED\', true);
+define(\'PWG_CHARSET\', \'utf-8\');
+define(\'DB_CHARSET\', \'utf8\');
+define(\'DB_COLLATE\', \'\');
+?>';
+
+  return $content;
+}
+
+function save_mysql_config() {
+  global $me, $conf, $prefixeTable;
+
+  $connection['db_host'] = $conf['db_host'];
+  $connection['db_user'] = $conf['db_user'];
+  $connection['db_password'] = $conf['db_password'];
+  $connection['db_base'] = $conf['db_base'];
+  $connection['prefix'] = $prefixeTable;
+  $me->addConnection('mysql', $connection);
+  $me->save_config();
+}
+?>
Index: /extensions/database_migration/include/tab_config.inc.php
===================================================================
--- /extensions/database_migration/include/tab_config.inc.php	(revision 6222)
+++ /extensions/database_migration/include/tab_config.inc.php	(revision 6222)
@@ -0,0 +1,128 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+define('DEFAULT_DB_SQLITE', 'native');
+
+load_language('install.lang', PHPWG_ROOT_PATH);
+
+include_once PHPWG_ROOT_PATH . 'admin/include/functions_install.inc.php';
+
+$Params = array('db_host', 'db_user', 'db_password', 'db_base');
+$extraParams = array('prefix');
+$mandatoryParams['sqlite'] = array('db_base');
+$mandatoryParams['pgsql'] = array('db_host', 'db_user', 'db_password', 'db_base');
+
+$dblayer = '';
+$default_prefix = 'piwigo_';
+$Actions = array('add', 'edit', 'del');
+$action = null;
+
+foreach (available_engines() as $key => $engine) {
+  if ($key=='mysql') {
+    continue;
+  }
+  $engines[$key] = $engine['label'];
+}
+
+$Connections = $me->getAllConnections();
+$connection = array('prefix' => $default_prefix);
+
+if (!empty($_GET['action']) && in_array($_GET['action'], $Actions)) {
+  $action = $_GET['action'];
+}
+
+if ($action=='del') {
+  if (empty($_GET['id']) || ($connection = $me->getConnection($_GET['id']))==null) {
+    $action = null;
+  } else {
+    $me->removeConnection($_GET['id']);
+    $me->save_config();
+    $_SESSION['dm_messages']['infos'] = l10n('Connection deleted successfully'); 
+    redirect($dm_base_url.'&amp;tab=config');
+  }
+}
+
+if ($action=='edit') {
+  if (empty($_GET['id']) || ($connection = $me->getConnection($_GET['id']))==null) {
+    $action = null;
+  } else {
+    $dblayer = $_GET['id'];
+  }
+}
+
+if (($action=='add') || ($action=='edit')) {
+  if (!empty($_POST) && isset($_POST['dblayer'])) {
+    $dblayer = $_POST['dblayer'];
+
+    foreach ($Params as $param) {
+      if (!empty($_POST[$param]) && in_array($param, $mandatoryParams[$dblayer])) {
+	$connection[$param] = trim($_POST[$param]," /\n\t\r\0\x0B");
+      } elseif (in_array($param, $mandatoryParams[$dblayer])) {
+	$GLOBALS['page']['errors'][] = l10n(sprintf('%s is required', ucfirst($param)));
+      } else {
+	$connection[$param] = '';
+      }
+    }
+    foreach ($extraParams as $param) {
+      if (!empty($_POST[$param])) {
+	$connection[$param] = trim($_POST['prefix'], " /\n\t\r\0\x0B");
+      } else {
+	$connection[$param] = '';
+      }
+    }
+  }  
+
+  if (!empty($_POST) && count($GLOBALS['page']['errors'])==0) {
+    $connection['label'] = $engines[$dblayer];
+    $me->addConnection($dblayer, $connection);
+    $me->save_config();
+    if ($action=='add') {
+      $_SESSION['dm_messages']['infos'] = l10n('Connection added successfully'); 
+    } else {
+      $_SESSION['dm_messages']['infos'] = l10n('Connection updated successfully'); 
+    }
+    redirect($dm_base_url.'&amp;tab=config');
+  }
+}
+
+if ($action=='edit' || $action=='add') {
+  foreach ($Params as $param) {
+    if (!empty($connection[$param])) {
+      $GLOBALS['template']->assign(strtoupper($param), $connection[$param]);
+    }
+  }
+  foreach ($extraParams as $param) {
+    $GLOBALS['template']->assign(strtoupper($param), $connection[$param]);
+  }
+  $GLOBALS['template']->assign('DBLAYER', $dblayer);
+}
+
+if (count($Connections)>0) {
+  $GLOBALS['template']->assign('CONNECTIONS', $Connections);
+}
+
+$GLOBALS['template']->assign('DM_ACTION', $action);
+$GLOBALS['template']->assign('F_DB_ENGINES', $engines);
+$GLOBALS['template']->assign('U_DM_LIST', $dm_base_url.'&amp;tab=config');
+$GLOBALS['template']->assign('U_DM_ADD_CONNECTION', $dm_base_url.'&amp;tab=config&amp;action=add');
+$GLOBALS['template']->assign('U_DM_DELETE_CONNECTION', $dm_base_url.'&amp;tab=config&amp;action=del&amp;id=');
+$GLOBALS['template']->assign('U_DM_EDIT_CONNECTION', $dm_base_url.'&amp;tab=config&amp;action=edit&amp;id=');
+?>
Index: /extensions/database_migration/include/tab_export.inc.php
===================================================================
--- /extensions/database_migration/include/tab_export.inc.php	(revision 6222)
+++ /extensions/database_migration/include/tab_export.inc.php	(revision 6222)
@@ -0,0 +1,65 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+if (empty($_SESSION['dm_export_done']) || !empty($_GET['action'])) {
+  $structure_file = PHPWG_ROOT_PATH .'/install/piwigo_structure-mysql.sql';
+  $content = file_get_contents($structure_file);
+  $pattern = '!CREATE TABLE `([^`]*)`!';
+  preg_match_all($pattern, $content, $matches);
+
+  $destination_dir = $conf['local_data_dir'] . '/plugins/database_migration';
+  mkgetdir($destination_dir);
+  $export = array();
+
+  foreach ($matches[1] as $table) {
+    $filename = sprintf('%s/%s.dump', $destination_dir, $table);
+    $fh = fopen($filename, 'w+');
+    $query = '
+SELECT * FROM '.$table;
+    $result = pwg_query($query);
+    $export[] = array('table' => $table, 'lines_count' => mysql_num_rows($result));
+    while ($row = pwg_db_fetch_assoc($result)) {
+      $insert = '
+INSERT INTO '.$table.' (';
+      $insert_values = ') VALUES (';
+
+      foreach ($row as $key => $value) {
+        $insert .= $key.', ';
+	if (is_null($value)) {
+	  $insert_values .= 'null, ';
+	} else {
+	  $insert_values .= '\''.$value.'\', ';
+	}
+      }
+      $insert = substr($insert, 0, -2);
+      $insert_values = substr($insert_values, 0, -2);
+      fputs($fh, $insert.$insert_values.');');
+    }
+    fclose($fh);
+  }
+
+  $_SESSION['dm_export_done'] = true;
+  $GLOBALS['template']->assign('EXPORT', $export);
+} else {
+  $GLOBALS['template']->assign('EXPORT_DONE', true);
+  $GLOBALS['template']->assign('U_FORCE_EXPORT', $dm_base_url.'&amp;tab=export&amp;action=force');
+}
+?>
Index: /extensions/database_migration/include/tab_import.inc.php
===================================================================
--- /extensions/database_migration/include/tab_import.inc.php	(revision 6222)
+++ /extensions/database_migration/include/tab_import.inc.php	(revision 6222)
@@ -0,0 +1,37 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+$allConnections = $me->getAllConnections();
+if (count($allConnections)>0) {
+  foreach ($allConnections as $connection_dblayer => $connection) {
+    $Connections[$connection_dblayer] = $connection['label'];
+  }
+  $template->assign('CONNECTIONS', $Connections);
+} else {
+  $GLOBALS['template']->assign('U_DM_ADD_CONNECTION', $dm_base_url.'&amp;tab=config&amp;action=add');
+}
+
+$me->dm_key = md5(uniqid('', true));
+$me->save_config();
+
+$GLOBALS['template']->assign('U_INSTALL_START', DM_PLUGIN_BASE_URL. '/install.php');
+$GLOBALS['template']->assign('DM_KEY', $me->dm_key);
+?>
Index: /extensions/database_migration/include/tab_migration.inc.php
===================================================================
--- /extensions/database_migration/include/tab_migration.inc.php	(revision 6222)
+++ /extensions/database_migration/include/tab_migration.inc.php	(revision 6222)
@@ -0,0 +1,72 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+if (!empty($_GET['dl']) && file_exists($conf['local_data_dir'].'/dm_'.$_GET['dl']))
+{
+  $filename = $conf['local_data_dir'].'/dm_'.$_GET['dl'];
+  header('Cache-Control: no-cache, must-revalidate');
+  header('Pragma: no-cache');
+  header('Content-Disposition: attachment; filename="database.inc.php"');
+  header('Content-Transfer-Encoding: binary');
+  header('Content-Length: '.filesize($filename));
+  echo file_get_contents($filename);
+  unlink($filename);
+  exit();
+} 
+
+include_once DM_PLUGIN_ROOT . '/include/functions.inc.php';
+
+load_language('install.lang', PHPWG_ROOT_PATH);
+
+$allConnections = $me->getAllConnections();
+if (count($allConnections)>0) {
+  foreach ($allConnections as $connection_dblayer => $connection) {
+    $Connections[$connection_dblayer] = $connection['label'];
+  }
+  $GLOBALS['template']->assign('CONNECTIONS', $Connections);
+} else {
+  $GLOBALS['template']->assign('U_DM_ADD_CONNECTION', $dm_base_url.'&amp;tab=config&amp;action=add');
+}
+
+if (!empty($_POST['dblayer']) && isset($Connections[$_POST['dblayer']])) {
+  $dblayer = $_POST['dblayer'];
+  $connection = $me->getConnection($dblayer);
+  $file_content = get_config_file_content($dblayer, $connection);
+
+  $config_file = PHPWG_ROOT_PATH . 'local/config/database.inc.php';
+  save_mysql_config();
+
+  if ( !($fp=@fopen( $config_file, 'w' ))) {
+    $tmp_filename = md5(uniqid('', true));
+    $fh = @fopen( $conf['local_data_dir'] . '/dm_' . $tmp_filename, 'w' );
+    @fputs($fh, $file_content, strlen($file_content));
+    @fclose($fh);
+  
+    $template->assign(array('config_creation_failed' => true,
+			    'config_url' => $dm_base_url.'&amp;tab=migration&amp;dl='.$tmp_filename,
+			    'config_file_content' => $file_content,
+			    )
+		      );
+  }
+  @fputs($fp, $file_content, strlen($file_content));
+  @fclose($fp);
+}
+?>
Index: /extensions/database_migration/include/tab_restore.inc.php
===================================================================
--- /extensions/database_migration/include/tab_restore.inc.php	(revision 6222)
+++ /extensions/database_migration/include/tab_restore.inc.php	(revision 6222)
@@ -0,0 +1,57 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+if (!empty($_GET['dl']) && file_exists($conf['local_data_dir'].'/dm_'.$_GET['dl']))
+{
+  $filename = $conf['local_data_dir'].'/dm_'.$_GET['dl'];
+  header('Cache-Control: no-cache, must-revalidate');
+  header('Pragma: no-cache');
+  header('Content-Disposition: attachment; filename="database.inc.php"');
+  header('Content-Transfer-Encoding: binary');
+  header('Content-Length: '.filesize($filename));
+  echo file_get_contents($filename);
+  unlink($filename);
+  exit();
+} 
+
+include_once DM_PLUGIN_ROOT . '/include/functions.inc.php';
+
+load_language('install.lang', PHPWG_ROOT_PATH);
+
+$connection = $me->getConnection('mysql');
+$file_content = get_config_file_content('mysql', $connection);
+$config_file = PHPWG_ROOT_PATH . 'local/config/database.inc.php';
+
+if ( !($fp=@fopen( $config_file, 'w' ))) {
+  $tmp_filename = md5(uniqid('', true));
+  $fh = @fopen( $conf['local_data_dir'] . '/dm_' . $tmp_filename, 'w' );
+  @fputs($fh, $file_content, strlen($file_content));
+  @fclose($fh);
+  
+  $template->assign(array('config_creation_failed' => true,
+			  'config_url' => $dm_base_url.'&amp;tab=migration&amp;dl='.$tmp_filename,
+			  'config_file_content' => $file_content,
+			  )
+		    );
+}
+@fputs($fp, $file_content, strlen($file_content));
+@fclose($fp);
+?>
Index: /extensions/database_migration/init.php
===================================================================
--- /extensions/database_migration/init.php	(revision 6222)
+++ /extensions/database_migration/init.php	(revision 6222)
@@ -0,0 +1,46 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+define('DM_PLUGIN_NAME', 'Database Migration');
+define('DM_PLUGIN_ROOT', dirname(__FILE__));
+define('DM_PLUGIN_LANG', DM_PLUGIN_ROOT . '/');
+define('DM_TEMPLATE', DM_PLUGIN_ROOT . '/template');
+define('DM_PLUGIN_BASE_URL', PHPWG_PLUGINS_PATH . basename(DM_PLUGIN_ROOT));
+define('DM_CSS', DM_PLUGIN_BASE_URL . '/css');
+define('DM_JS', DM_PLUGIN_BASE_URL . '/js');
+
+include_once DM_PLUGIN_ROOT . "/include/config.class.php";
+
+load_language('plugin.lang', DM_PLUGIN_LANG);
+
+$plugin_config = new dmConfig(DM_PLUGIN_ROOT, DM_PLUGIN_NAME);
+$plugin_config->load_config();
+
+if (defined('IN_ADMIN')) { 
+  add_event_handler('get_admin_plugin_menu_links', array($plugin_config, 'plugin_admin_menu')); 
+}
+
+set_plugin_data($plugin['id'], $plugin_config);
+?>
Index: /extensions/database_migration/install.php
===================================================================
--- /extensions/database_migration/install.php	(revision 6222)
+++ /extensions/database_migration/install.php	(revision 6222)
@@ -0,0 +1,135 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+define('PHPWG_ROOT_PATH', '../../');
+define('DM_PLUGIN_ROOT', dirname(__FILE__));
+define('PHPWG_DEFAULT_LANGUAGE', 'en_UK');
+
+include_once PHPWG_ROOT_PATH . 'include/functions.inc.php';
+include_once DM_PLUGIN_ROOT . '/include/config.class.php';
+
+load_language('plugin.lang', DM_PLUGIN_ROOT.'/');
+
+$conf['local_data_dir'] = PHPWG_ROOT_PATH . '_data';
+$conf['show_queries'] = false;
+$conf['php_extension_in_urls'] = true;
+$conf['debug_l10n'] = false;
+
+$response = array();
+
+if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
+  $xmlhttprequest = true;
+} else {
+  $xmlhttprequest = false;
+}
+
+$me = new dmConfig(DM_PLUGIN_ROOT, 'database_migration');
+$me->load_config();
+
+if (!empty($_POST['dm_key']) && ($_POST['dm_key']==$me->dm_key)) {
+  $connection = $me->getConnection($_POST['dblayer']);
+  if ($connection==null) {
+    addError(l10n('unknown dblayer'));
+  } else {
+    $dblayer = $_POST['dblayer'];
+    include_once PHPWG_ROOT_PATH . 'include/dblayer/functions_'.$dblayer.'.inc.php';
+
+    $pwg_db_link = pwg_db_connect($connection['db_host'], $connection['db_user'], $connection['db_password'], $connection['db_base']);
+    $result = execute_sqlfile(PHPWG_ROOT_PATH.'install/piwigo_structure-'.$dblayer.'.sql',
+			      'piwigo_',
+			      $connection['prefix']);
+    if (!$result) {
+      addError(l10n('Cannot create struture'));
+    } else {
+      $structure_file = PHPWG_ROOT_PATH .'/install/piwigo_structure-mysql.sql';
+      $content = file_get_contents($structure_file);
+      $pattern = '!CREATE TABLE `([^`]*)`!';
+      preg_match_all($pattern, $content, $matches);
+    
+      $Tables = $matches[1];
+      $ignoreTables = array('piwigo_history', 'piwigo_history_summary', 'piwigo_sessions', 'piwigo_user_cache', 'piwigo_user_cache_categories');
+      $dump_dir = $conf['local_data_dir'].'/plugins/database_migration/';
+      foreach ($Tables as $table) {
+	if (in_array($table, $ignoreTables)) {
+	  continue;
+	}
+	$result = execute_sqlfile("{$dump_dir}/{$table}.dump",
+				  'piwigo_',
+				  $connection['prefix']);
+	if (!$result) {
+	  addError(l10n(sprintf('Cannot import %s content', $table)));
+	  break;
+	}
+      }
+    }
+  }
+} else {
+  addError(l10n('Hacking attempt!'));
+}
+
+if (empty($response)) {
+  addInfo(l10n('Import completed'));
+}
+
+if ($xmlhttprequest) {
+  header("Content-Type: application/json");
+  echo json_encode($response);
+  exit();
+} else {
+  echo '<pre>', print_r($response, true), '</pre>';
+}
+
+function addError($message) {
+  global $response;
+
+  $response['error'] = $message;
+}
+
+function addInfo($message) {
+  global $response;
+
+  $response['info'] = $message;
+}
+
+function execute_sqlfile($filepath, $replaced, $replacing)
+{
+  $sql_lines = file($filepath);
+  $query = '';
+  foreach ($sql_lines as $sql_line)
+    {
+      $sql_line = trim($sql_line);
+      if (preg_match('/(^--|^$)/', $sql_line))
+	{
+	  continue;
+	}
+      $query.= ' '.$sql_line;
+      if (preg_match('/;$/', $sql_line))
+	{
+	  $query = trim($query);
+	  $query = str_replace($replaced, $replacing, $query);
+      
+	  $result = pwg_query($query);	
+	  $query = '';
+	}
+    }
+  return true;
+}
+?>
Index: /extensions/database_migration/js/admin.js
===================================================================
--- /extensions/database_migration/js/admin.js	(revision 6222)
+++ /extensions/database_migration/js/admin.js	(revision 6222)
@@ -0,0 +1,23 @@
+$(function() {
+    $('a.confirm').
+      click(function() {
+          if (!confirm($(this).attr('title'))) {
+            return false;
+          }
+        });
+    
+    $option_selected = $('#dblayer').attr('value');
+    if ($option_selected=='sqlite' || $option_selected=='pdo-sqlite') {
+       $('input[name=db_host],input[name=db_user],input[name=db_password]').parent().parent().hide();
+    }
+
+    $('#dblayer').change(function() {
+        $db = this;
+        if ($db.value=='sqlite' || $db.value=='pdo-sqlite') {
+           $('input[name=db_host],input[name=db_user],input[name=db_password]').parent().parent().hide();
+        } else {
+           $('input[name=db_host],input[name=db_user],input[name=db_password]').parent().parent().show();
+        }
+      });
+
+  });
Index: /extensions/database_migration/js/install.js
===================================================================
--- /extensions/database_migration/js/install.js	(revision 6222)
+++ /extensions/database_migration/js/install.js	(revision 6222)
@@ -0,0 +1,20 @@
+function onSuccess(data) {
+  if (data.error) {
+    $('#dm-messages').html('<p>'+data.error+'</p>').addClass('errors');
+  } else {
+    $('#dm-messages').html('<p>'+data.info+'</p>').addClass('infos');
+  }
+}
+
+$(function() {
+    $('#dm-install').click(function() {
+	$.post($('#dm-form-import').attr('action'),
+	       {dm_key:$('#dm_key').val(),dblayer:$('#dblayer').val()},
+	       function(data) {
+		 onSuccess(data);
+	       },
+	       'json'
+	       );
+	return false;
+      });
+  });
Index: /extensions/database_migration/language/en_UK/index.php
===================================================================
--- /extensions/database_migration/language/en_UK/index.php	(revision 6222)
+++ /extensions/database_migration/language/en_UK/index.php	(revision 6222)
@@ -0,0 +1,28 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header("Request-URI: $url");
+header("Content-Location: $url");
+header("Location: $url");
+exit();
+?>
Index: /extensions/database_migration/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/database_migration/language/en_UK/plugin.lang.php	(revision 6222)
+++ /extensions/database_migration/language/en_UK/plugin.lang.php	(revision 6222)
@@ -0,0 +1,22 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+?>
Index: /extensions/database_migration/language/fr_FR/description.txt
===================================================================
--- /extensions/database_migration/language/fr_FR/description.txt	(revision 6222)
+++ /extensions/database_migration/language/fr_FR/description.txt	(revision 6222)
@@ -0,0 +1,1 @@
+Ce plugin vous permet de changer de base de données, de mysql vers SQLite ou PostgreSQL.
Index: /extensions/database_migration/language/fr_FR/index.php
===================================================================
--- /extensions/database_migration/language/fr_FR/index.php	(revision 6222)
+++ /extensions/database_migration/language/fr_FR/index.php	(revision 6222)
@@ -0,0 +1,28 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header("Request-URI: $url");
+header("Content-Location: $url");
+header("Location: $url");
+exit();
+?>
Index: /extensions/database_migration/language/fr_FR/plugin.lang.php
===================================================================
--- /extensions/database_migration/language/fr_FR/plugin.lang.php	(revision 6222)
+++ /extensions/database_migration/language/fr_FR/plugin.lang.php	(revision 6222)
@@ -0,0 +1,56 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+$lang['MySQL to others databases migration plugin'] = 'Plugin de migration de MySQL vers d\'autres base de données';
+$lang['Import process'] = 'Processus d\'import';
+$lang['New'] = 'Nouvelle';
+$lang['List'] = 'Liste';
+$lang['Edit'] = 'Editer';
+$lang['No connection defined'] = 'Pas de connexion définie';
+$lang['First we will create new configuration file for your new database.'] = 'Tout d\'abord, vous devez créer un nouveau fichier de configuration pour votre nouvelle base de données';
+$lang['Export done'] = 'Export terminé avec succès';
+$lang['Force export'] = 'Forcer un nouvel export';
+$lang['lines'] = 'lignes';
+$lang['Creation of new database'] = 'Création de la nouvelle base de données';
+$lang['Installation of new tables'] = 'Installation de la nouvelle base de données';
+$lang['Restore content into your new database'] = 'Restaurer le contenu dans la nouvelle base de données';
+$lang['Database to populate'] = 'Base de données à remplir';
+$lang['Choose connection'] = 'Choisissez une connexion';
+$lang['You must define at least one connection to an new database'] = 'Vous devez commencer par créer une nouvelle connexion à une base de données';
+$lang['New connection'] = 'Nouvelle connexion';
+$lang['Edit database configuration'] = 'Editer la configuration de la base de données';
+$lang['New database configuration'] = 'Nouvelle configuration de la base de données';
+$lang['Restore config for Mysql database'] = 'Retour à la configuration avec Mysql comme base de données';
+
+$lang['Configuration'] = 'Configuration';
+$lang['Export'] = 'Export';
+$lang['Import'] = 'Import';
+$lang['Migration'] = 'Migration';
+$lang['Restore'] = 'Retour à Mysql';
+$lang['%s is required'] = 'Le champ %s est obligatoire';
+$lang['Connection added successfully'] = 'Connexion ajoutée avec succès';
+$lang['Connection deleted successfully'] = 'Connexion supprimée avec succès';
+$lang['Connection updated successfully'] = 'Connexion mise à jour avec succès';
+$lang['unknown dblayer'] = 'Base de données inconnue';
+$lang['Cannot create struture'] = 'Création de la struture de la base de données impossible';
+$lang['Cannot import %s content'] = 'Import du contenu de la table %s impossible';
+$lang['Import completed'] = 'Import complet terminé';
+?>
Index: /extensions/database_migration/language/templates/index.php
===================================================================
--- /extensions/database_migration/language/templates/index.php	(revision 6222)
+++ /extensions/database_migration/language/templates/index.php	(revision 6222)
@@ -0,0 +1,28 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header("Request-URI: $url");
+header("Content-Location: $url");
+header("Location: $url");
+exit();
+?>
Index: /extensions/database_migration/language/templates/plugin.lang.php
===================================================================
--- /extensions/database_migration/language/templates/plugin.lang.php	(revision 6222)
+++ /extensions/database_migration/language/templates/plugin.lang.php	(revision 6222)
@@ -0,0 +1,58 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+// template
+$lang['MySQL to others databases migration plugin'] = 'MySQL to others databases migration plugin';
+$lang['Import process'] = 'Import process';
+$lang['New'] = 'New';
+$lang['List'] = 'List';
+$lang['Edit'] = 'Edit';
+$lang['No connection defined'] = 'No connection defined';
+$lang['First we will create new configuration file for your new database.'] = 'First we will create new configuration file for your new database.';
+$lang['Export done'] = 'Export done';
+$lang['Force export'] = 'Force export';
+$lang['lines'] = 'lines';
+$lang['Creation of new database'] = 'Creation of new database';
+$lang['Installation of new tables'] = 'Installation of new tables';
+$lang['Restore content into your new database'] = 'Restore content into your new database';
+$lang['Database to populate'] = 'Database to populate';
+$lang['Choose connection'] = 'Choose connection';
+$lang['You must define at least one connection to an new database'] = 'You must define at least one connection to an new database';
+$lang['New connection'] = 'New connection';
+$lang['Edit database configuration'] = 'Edit database configuration';
+$lang['New database configuration'] = 'New database configuration';
+$lang['Restore config for Mysql database'] = 'Restore config for Mysql database';
+
+// php
+$lang['Configuration'] = 'Configuration';
+$lang['Export'] = 'Export';
+$lang['Import'] = 'Import';
+$lang['Migration'] = 'Migration';
+$lang['Restore'] = 'Restore';
+$lang['%s is required'] = '%s is required';
+$lang['Connection added successfully'] = 'Connection added successfully';
+$lang['Connection deleted successfully'] = 'Connection deleted successfully';
+$lang['Connection updated successfully'] = 'Connection updated successfully';
+$lang['unknown dblayer'] = 'unknown dblayer';
+$lang['Cannot create struture'] = 'Cannot create struture';
+$lang['Cannot import %s content'] = 'Cannot import %s content';
+$lang['Import completed'] = 'Import completed';
+?>
Index: /extensions/database_migration/main.inc.php
===================================================================
--- /extensions/database_migration/main.inc.php	(revision 6222)
+++ /extensions/database_migration/main.inc.php	(revision 6222)
@@ -0,0 +1,36 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+/*
+Plugin Name: Database Migration
+Version: 0.1.0
+Description: That plugin helps you migrate from mysql to others databases
+Plugin URI: http://piwigo.org/ext/extension_links.php?eid=NNN
+Author: nikrou
+Author URI: http://www.nikrou.net/
+*/
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+include_once(dirname(__FILE__).'/init.php');
+?>
Index: /extensions/database_migration/maintain.inc.php
===================================================================
--- /extensions/database_migration/maintain.inc.php	(revision 6222)
+++ /extensions/database_migration/maintain.inc.php	(revision 6222)
@@ -0,0 +1,40 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | database_migration - a plugin for Piwigo                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License version 2 as     |
+// | published by the Free Software Foundation                             |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA                                                     |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+function plugin_install($plugin_id, $plugin_version, &$errors) {
+}
+
+function plugin_activate($plugin_id, $plugin_version, &$errors) {
+}
+
+function plugin_deactivate($plugin_id) { 
+}
+
+function plugin_uninstall($plugin_id) {
+  if (file_exists($GLOBALS['conf']['local_data_dir'].'/plugins/'.$plugin_id.'.dat')) {
+    unlink($GLOBALS['conf']['local_data_dir'].'/plugins/'.$plugin_id.'.dat');
+  }
+}
+?>
Index: /extensions/database_migration/template/admin.tpl
===================================================================
--- /extensions/database_migration/template/admin.tpl	(revision 6222)
+++ /extensions/database_migration/template/admin.tpl	(revision 6222)
@@ -0,0 +1,9 @@
+{html_head} 
+<link rel="stylesheet" type="text/css" href="{$DM_CSS}/admin.css">
+{/html_head}
+
+<div class="titrePage">
+  <h2>{'MySQL to others databases migration plugin'|translate}</h2>
+</div>
+
+{include file="$tab_content"} 
Index: /extensions/database_migration/template/admin_config.tpl
===================================================================
--- /extensions/database_migration/template/admin_config.tpl	(revision 6222)
+++ /extensions/database_migration/template/admin_config.tpl	(revision 6222)
@@ -0,0 +1,44 @@
+{known_script id="jquery" src=$ROOT_URL|cat:"themes/default/js/jquery.packed.js"}
+{html_head}
+<script type="text/javascript" src="{$DM_JS}/admin.js"></script>
+{/html_head}
+
+<ul class="actions">
+  <li><a href="{$U_DM_LIST}">{'List'|@translate}</a>|</li>
+  <li><a href="{$U_DM_ADD_CONNECTION}">{'New'|@translate}</a></li>  
+</ul>
+
+{if (($DM_ACTION=='add') || ($DM_ACTION=='edit'))}
+{include file="$DM_TPL/form.tpl"}
+{/if}
+
+<table class="table2">
+  <thead>
+    <tr class="throw">
+      <th>{'Database type'|@translate}</th>
+      <th colspan="2"></th>
+    </tr>
+  </thead>
+  <tbody>
+    {foreach from=$CONNECTIONS key=dblayer item=connection name=connection_loop}
+    <tr class="{if $smarty.foreach.connection_loop.index is odd}row1{else}row2{/if}">
+      <td>
+	{$F_DB_ENGINES.$dblayer}
+      </td>
+      <td>
+        <a href="{$U_DM_EDIT_CONNECTION}{$dblayer}"><span>{'Edit'|@translate}</span></a>
+      </td>
+      <td>
+        <a class="confirm" title="{'Are you sure ?'|@translate}" href="{$U_DM_DELETE_CONNECTION}{$dblayer}"><span>{'Delete'|@translate}</span></a>
+      </td>
+    </tr>
+    {foreachelse}
+    <tr>
+      <td colspan="3">
+	<p>{'No connection defined'|@translate}</p>
+	<p>{'First we will create new configuration file for your new database.'|@translate}</p>
+      </td>
+    </tr>
+    {/foreach}
+  </tbody>
+</table>
Index: /extensions/database_migration/template/admin_export.tpl
===================================================================
--- /extensions/database_migration/template/admin_export.tpl	(revision 6222)
+++ /extensions/database_migration/template/admin_export.tpl	(revision 6222)
@@ -0,0 +1,9 @@
+{if ($EXPORT_DONE)}
+<p>{'Export done'|@translate}</p>
+
+<p><a href="{$U_FORCE_EXPORT}">{'Force export'|@translate}</a></p>
+{else}
+{foreach from=$EXPORT item=export}
+<p>{$export.table} : {$export.lines_count} {'lines'|@translate}<p>
+{/foreach}
+{/if}
Index: /extensions/database_migration/template/admin_import.tpl
===================================================================
--- /extensions/database_migration/template/admin_import.tpl	(revision 6222)
+++ /extensions/database_migration/template/admin_import.tpl	(revision 6222)
@@ -0,0 +1,40 @@
+{known_script id="jquery" src=$ROOT_URL|@cat:"themes/default/js/jquery.packed.js"}
+{html_head}
+<script type="text/javascript" src="{$DM_JS}/install.js"></script>
+{/html_head}
+
+<h3>{'Import process'|@translate}</h3>
+<ul class="process">
+  <li class="step-1">{'Creation of new database'|@translate}</li>
+  <li class="step-2">{'Installation of new tables'|@translate}</li>
+  <li class="step-3">{'Restore content into your new database'|@translate}</li>
+</ul>
+
+<div id="dm-messages">
+</div>
+
+{if ($CONNECTIONS)}
+<form action="{$U_INSTALL_START}" method="post" id="dm-form-import">
+  <fieldset>
+    <legend>{'Database to populate'|@translate}</legend>
+    <p class="field">
+      <label>{'Choose connection'|@translate}
+	<select id="dblayer" name="dblayer">
+	  <option value="">---</option>
+	  {html_options options=$CONNECTIONS}
+	</select>
+      </label>
+    </p>
+    <p>
+      <input type="hidden" id="dm_step" name="dm_step" value="1">
+      <input type="hidden" id="dm_key" name="dm_key" value="{$DM_KEY}">
+      <input id="dm-install" class="submit" type="submit" name="submit" value="{'Submit'|translate}">
+    </p>
+  </fieldset>
+</form>
+{else}
+<p>
+  {'You must define at least one connection to an new database'|@translate} : 
+  <a href="{$U_DM_ADD_CONNECTION}">{'New connection'|@translate}<a>
+</p>
+{/if}
Index: /extensions/database_migration/template/admin_migration.tpl
===================================================================
--- /extensions/database_migration/template/admin_migration.tpl	(revision 6222)
+++ /extensions/database_migration/template/admin_migration.tpl	(revision 6222)
@@ -0,0 +1,43 @@
+{if ($CONNECTIONS)}
+<form action="" method="post">
+  <fieldset>
+    <legend>{'Database to populate'|@translate}</legend>
+    <p class="field">
+      <label>{'Choose connection'|@translate}
+	<select id="dblayer" name="dblayer">
+	  <option value="">---</option>
+	  {html_options options=$CONNECTIONS}
+	</select>
+      </label>
+    </p>
+  </fieldset>
+  <p>
+    <input class="submit" type="submit" name="submit" value="{'Submit'|translate}">
+  </p>
+</form>
+{else}
+<p>
+  {'You must define at least one connection to an new database'|@translate} : 
+  <a href="{$U_DM_ADD_CONNECTION}">{'New connection'|@translate}<a>
+</p>
+{/if}
+
+{if isset($config_creation_failed)}
+<div class="config_creation_failed">
+  <p style="margin-left:30px;">
+    <strong>{'Creation of config file local/config/database.inc.php failed.'|@translate}</strong>
+  </p>
+  <ul>
+    <li>
+      <p>{'You can download the config file and upload it to local/config directory of your installation.'|@translate}</p>
+      <p>
+        <a href="{$config_url}">{'Download the config file'|@translate}</a>
+      </p>
+    </li>
+    <li>
+      <p>{'An alternate solution is to copy the text in the box above and paste it into the file "local/config/database.inc.php" (Warning : database.inc.php must only contain what is in the textarea, no line return or space character)'|@translate}</p>
+      <textarea rows="15" cols="70">{$config_file_content}</textarea>
+    </li>
+  </ul>
+</div>
+{/if}
Index: /extensions/database_migration/template/admin_restore.tpl
===================================================================
--- /extensions/database_migration/template/admin_restore.tpl	(revision 6222)
+++ /extensions/database_migration/template/admin_restore.tpl	(revision 6222)
@@ -0,0 +1,22 @@
+<h3>{'Restore config for Mysql database'|@translate}</h3>
+
+{if isset($config_creation_failed)}
+<div class="config_creation_failed">
+  <p style="margin-left:30px;">
+    <strong>{'Creation of config file local/config/database.inc.php failed.'|@translate}</strong>
+  </p>
+  <ul>
+    <li>
+      <p>{'You can download the config file and upload it to local/config directory of your installation.'|@translate}</p>
+      <p>
+        <a href="{$config_url}">{'Download the config file'|@translate}</a>
+      </p>
+    </li>
+    <li>
+      <p>{'An alternate solution is to copy the text in the box above and paste it into the file "local/config/database.inc.php" (Warning : database.inc.php must only contain what is in the textarea, no line return or space character)'|@translate}</p>
+      <textarea rows="15" cols="70">{$config_file_content}</textarea>
+    </li>
+  </ul>
+</div>
+{/if}
+
Index: /extensions/database_migration/template/form.tpl
===================================================================
--- /extensions/database_migration/template/form.tpl	(revision 6222)
+++ /extensions/database_migration/template/form.tpl	(revision 6222)
@@ -0,0 +1,51 @@
+<div id="add-form">
+  <form action="" method="post">
+    <fieldset>
+      {if $DM_ACTION=='edit'}
+      <legend>{'Edit database configuration'|@translate}</legend>
+      <p class="field">
+	<label>{'Database type'|@translate}</label>
+	<span class="value">{$F_DB_ENGINES.$DBLAYER}</span>
+	<input id="dblayer" type="hidden" name="dblayer" value="{$DBLAYER}">
+      </p>
+      {else}
+      <legend>{'New database configuration'|@translate}</legend>
+      <p class="field">
+	<label>{'Database type'|@translate}
+	  <select name="dblayer" id="dblayer">
+	    {html_options options=$F_DB_ENGINES selected=$DBLAYER}
+	  </select>    
+	</label>
+      </p>
+      {/if}
+      <p class="field">
+	<label>{'Host'|@translate}
+	  <input type="text" name="db_host" value="{$DB_HOST}" tabindex="1">
+	</label>
+      </p>
+      <p class="field">
+	<label>{'User'|@translate}
+	  <input type="text" name="db_user" value="{$DB_USER}" tabindex="2">
+	</label>
+      </p>
+      <p class="field">
+	<label>{'Password'|@translate}
+	  <input type="text" name="db_password" value="{$DB_PASSWORD}" tabindex="3">      
+	</label>
+      </p>
+      <p class="field">
+	<label>{'Database name'|@translate}
+	  <input type="text" name="db_base" value="{$DB_BASE}" tabindex="4">      
+      </label>
+      </p>
+      <p class="field">
+	<label>{'Database table prefix'|@translate}
+	  <input type="text" name="prefix" value="{$PREFIX}" tabindex="5">      
+	</label>
+      </p>
+    </fieldset>
+    <p>
+      <input class="submit" type="submit" name="submit" value="{'Submit'|translate}" tabindex="6">
+    </p>
+  </form>
+</div>
